package com.qmth.teachcloud.mark.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.qmth.teachcloud.common.entity.MarkQuestion;
import com.qmth.teachcloud.common.enums.mark.MarkMode;
import com.qmth.teachcloud.common.enums.mark.MarkPaperStatus;
import com.qmth.teachcloud.mark.bean.marker.MarkerAddParam;
import com.qmth.teachcloud.mark.dto.mark.entrance.MarkEntranceDto;
import com.qmth.teachcloud.mark.dto.mark.manage.MarkQualityChartDto;
import com.qmth.teachcloud.mark.dto.mark.manage.MarkQualityDto;
import com.qmth.teachcloud.mark.dto.mark.manage.MarkUserGroupProgressDto;
import com.qmth.teachcloud.common.bean.dto.mark.MarkUser;
import com.qmth.teachcloud.mark.entity.MarkUserQuestion;
import com.baomidou.mybatisplus.extension.service.IService;
import com.qmth.teachcloud.mark.enums.QuestionModel;

import java.util.List;

/**
 * <p>
 * 评卷员表 服务类
 * </p>
 *
 * @author xf
 * @since 2023-09-22
 */
public interface MarkUserQuestionService extends IService<MarkUserQuestion> {

    IPage<MarkEntranceDto> listEntranceGroup(Long examId, Long openCollegeId, Long courseCode, String paperNumber,
            Integer pageNumber, Integer pageSize);

    List<MarkUser> listGroupUserByExamIdAndPaperNumberAndQuestionIdAndClassName(Long examId, String paperNumber, Long questionId, String className);

    IPage<MarkUserGroupProgressDto> pageGroupUserByExamIdAndPaperNumberAndQuestionId(Long examId, String paperNumber,
                                                                                     Long questionId, String loginName, String className, Boolean marked, Integer pageNumber, Integer pageSize);

    void addMarkUserQuestion(MarkerAddParam markerAddParam);

    void setTopCount(List<Long> markUserQuestionIds, Integer topCount);

    MarkUserQuestion getByExamIdAndPaperNumberAndQuestionIdAndUserId(Long examId, String paperNumber, Long questionId, Long userId);

    void deleteMarker(MarkUserQuestion markUserQuestion);

    void releaseMarker(List<Long> markUserGroupIds);

    boolean resetMarker(MarkUserQuestion markUserGroup);

    void resetById(Long id);

    IPage<MarkQualityDto> pageQuality(Long examId, String paperNumber, Long questionId, String loginName, Integer pageNumber, Integer pageSize);

    void updateQuality(Long examId, String paperNumber, Long questionId);

    List<MarkUserQuestion> listByExamIdAndPaperNumberAndQuestionId(Long examId, String paperNumber, Long questionId);

    void updateQualityById(Long markUserGroupId, int finishCount, int headerFinishCount, int validCount, double v,
            double avgScore, double stdevScore, double maxScore, double minScore);

    List<MarkQualityChartDto> listQualityChart(Long examId, String paperNumber, Long questionId);

    List<MarkUserQuestion> listByExamIdAndPaperNumberAndUserId(Long examId, String paperNumber, Long userId);

    void deleteByExamIdAndPaperNumberAndQuestionId(Long examId, String paperNumber, Long questionId);

    void updateMode(Long examId, String paperNumber, Long userId, MarkMode mode, QuestionModel questionModel);

    List<String> listBindMarkers(Long examId, String paperNumber, Long questionId);

    /**
     * 查询评卷任务待办/已办数量
     *
     * @param userId 用户id
     * @param status 试卷状态
     * @return 任务数量
     */
    int countByMarkTask(Long userId, MarkPaperStatus status);

    void updateRejectCountByExamIdAndPaperNumberAndQuestionIdAndUserId(Long examId, String paperNumber, Long questionId, Long userId);

    void saveDefaultMarker(Long examId, String paperNumber, List<MarkQuestion> markQuestions);

    List<String> countClassByExamIdAndPaperNumberAndQuestionId(Long examId, String paperNumber, Long questionId);
}
